<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Graham Featherstone - Project 8</title>
    <link href="../../styles.css" rel="stylesheet" />
</head>

<body>
    <header>
        <div class="container">
            <div class="text-container">
                <h1>Graham Featherstone</h1>
                <p>Chemical Engineering Student | Teacher | Enthusiast</p>
            </div>
            <img src="../../Cropped2.jpg" width="200px">
        </div>
    </header>

    <section>
        <h1>Project 8</h1>
        <h2>
            Key Objectives
        </h2>
        <hl>
            <li>Play with the Seeed Studio Xiao-RP20</li>
            <li>Make it do stuff</li>
            <li>Try not to throw it at the wall</li>
        </hl>
    </section>

    <section>
        <h1>How it went</h1>
        <p>
            The project went surprisingly well once I started understanding the logic behind the continuous loop that
            is running on the RP2040. Although I have some software programming experience with Java, things work
            differently when
            the system is constantly looping through the commands. One of the most difficult parts was the learn how the
            buttons function
            and how they detected high/low. Once I begun understanding how these different components started working, I
            used the diagrams that we were
            given during the board milling sessions to learn how to control specific outputs and inputs on the device.
        </p>
        <div class="image-container">
            <img src="../Project6/Project6Images/Primary1.jpg" width="500px">
            <img src="../Project6/Project6Images/Primary2.jpg" width="500px">
        </div>
        <p>
            From the above digram on the right, I was able to tell that there were 3 LED's that are present on the board
            (also because I installed them).
            So, aside from the first objective in project 6 (illuminating one light), I wanted to try to illuminate all
            3 LED's and make sure that they were
            installed properly and were functioning. I did this by utilizing the original blink code that we had used
            when first testing the board, and the pin coordinates
            that are shown on the right image above.
        </p>
        <div class="image-container">
            <img src="Project8Images/Image1.jpg" width="500px">
            <img src="Project8Images/Image2.jpg" width="500px">
        </div>
        <div class="image-container">
            <img src="Project8Images/Code1.png" width="500px">
        </div>
        <center>
            <video width="500" height="500" controls>
                <source src="Project8Images/Video1.mp4" type="video/mp4">
            </video>
        </center>
        <p>
            As you can see in the above video, I was successful in initializing all 3 LED lights. However, LED2 (code
            above) from output D6 needed me to
            bridge the connection at the pin connector with my multimeter to complete the circuit. I was also able to
            provide energy with my multimeter to first
            test that the LED functioned correctly by simply putting a current across it.
        </p>
    </section>

    <section>
        <h1>Hardware coding takes me to school - To school and back again</h1>
        <p>
            The next code that I wanted to create was to have the lights blink in a specific order when I held down the
            button. This was
            actually far more difficult than just software where I could initialize and exit loops at will.
            Unfortunately I did not take a picture of my...easily 20-25
            attempts to make this code work (approximately 4-5 hours), but through this difficulty I started to
            understand how the functions and coding of this piece of hardware functions.
            It is actually quite difficult to replace troubleshooting this issue alone, but at the end I was successful
            in blinking the two led's (D6 omitted because of the bridge). See the video below. I
            first blink LED, then LED1, then LED + LED1, and then they all turn off and the loop repeats as long as I
            hold down the button. I could speed it up, but I wanted to satisfaction of watching these LED's light
            up slowly because they caused me so much pain. 2000ms is my best offer.
        </p>
        <center>
            <video width="500" height="500" controls>
                <source src="Project8Images/Video2.mp4" type="video/mp4">
            </video>
        </center>
        <div class="image-container">
            <img src="Project8Images/Code2.png" width="500px">
        </div>
        <h1>From here things went wonky</h1>
        <p>
            After my early success, I was feeling quite confident. I decided to try to add the RBG LED on the RP2040
            into the mix... I know that there is an easier way to do this, but I have dug the hole so far...
            I unfortunately did not have much success with the RBG lights, and I am going to need to experiment more
            tomorrow. Maybe I can write some fresh code from the start and avoid using 6 counters...It seems to work,
            but the RBG colors are supposed to
            turn off in between the cycles and I am not able to do that so far. I will try again soon.
        </p>
        <center>
            <video width="500" height="500" controls>
                <source src="Project8Images/Video3.mp4" type="video/mp4">
            </video>
        </center>
        <div class="image-container">
            <img src="Project8Images/Code3.png" width="500px">
        </div>

        <p>
            I found the issue...for the RBG_PIN - HIGH is OFF, LOW is ON! :O This still doesn't fix my disgusting code
            though...
            Below is two videos, a modified LED-BLINK file provided by our course instructor (I was practicing with
            On/Off), and the final functioning "blink all the lights in sequence code".
        </p>
        <center>
            <video width="500" height="500" controls>
                <source src="Project8Images/Video4.mp4" type="video/mp4">
            </video>
        </center>
        <center>
            <video width="500" height="500" controls>
                <source src="Project8Images/Video5.mp4" type="video/mp4">
            </video>
        </center>
        <div class="image-container">
            <img src="Project8Images/Code4.png" width="500px">
            <img src="Project8Images/Code5.png" width="500px">
        </div>
    </section>

    <section>
        <h1>
            Trying to learn how to use the NeoPixel
        </h1>
        <p>
            First I started with the <a href= "https://wiki.seeedstudio.com/XIAO-RP2040-with-Arduino/">Seeeded RP2040 wiki page</a> to help me to understand how to program with the NeoPixel and install the libraries. 
            <div class="image-container">
                <img src="Project8Images/Image3.jpg" width="500px">
            </div>
            I started by installing the libraries (left) by searching the Adafruit_NeoPixel in the library manager. Once I had imported the library, I copied the test code from the NeoPixel wiki page to test 
            that it functions. Below is a video of the NeoPixel functioning. 
        </p>
        <center>
            <video width="500" height="500" controls>
                <source src="Project8Images/NeoPixelStart.mp4" type="video/mp4">
            </video>
        </center>
        <p>
            I then tried the code provided by the course and I could not get it functioning correctly. In this case, I began troubleshooting the code with my other code as reference to find out how to use my button at D1 to control 
            the NeoPixel LED. I also programmed it to change very rapidly (disco ball style), and then to transition really slowly (2000ms delay), and turn off after randomizing the colour. This final one is shown below along with the code. 

        </p>
        <center>
            <video width="500" height="500" controls>
                <source src="Project8Images/Video6.mp4" type="video/mp4">
            </video>
        </center>
        <div class="image-container">
            <img src="Project8Images/Code6.png" width="500px">
            <img src="Project8Images/Image5.jpg" width="500px">
        </div>
        <p><a href="https://adafruit.github.io/Adafruit_NeoPixel/html/class_adafruit___neo_pixel.html"> This website</a> helped me to naviage the NeoPixel commands.</p>
    </section>

    <section>
        <h1>
            Serial - Not to be confused with Cereal
        </h1>
        <p>

        </p>
    </section>



</body>

</html>